function out = cdrn(x,y,N,bpb,s1,s2)
r = size(x,1);
c = size(x,2);

count = 0;
correctBits = 0;
correctBlocks = 0;

corrflags = zeros(r/N,c/N);

for rr = N/2:N:r,
    for cc = N/2:N:c,
        count = count + 1;
        if x(rr,cc)==y(rr,cc), 
            correctBlocks = correctBlocks + 1;
            corrflags((rr+N/2)/N,(cc+N/2)/N) = 1;
        end
    end
end

%out = 100*correctBlocks/count;

imr = r/s1;
imc = c/s2;
blr = s1/N;
blc = s2/N;

out = zeros(1,imr*imc);
count = 0;
for rr = 1:imr,
    for cc = 1:imc,
        tmp = corrflags((rr-1)*blr+1:rr*blr,(cc-1)*blc+1:cc*blc);
        count = count+1;
        out(count) = (sum2(tmp)/(blr*blc))*100;
    end    
end
