% generate data and save to mat files, to save computaional time
genCXZs;

% LMS training:
clear all;
load CXZpmrr_25;
wmcx = imread('wmcxrr.bmp');wmcx = wmcx(1:2400,1:2400);wmcz = imread('wmczrr.bmp');wmcz = wmcz(1:2400,1:2400);wmcx = [wmcx,wmcx];wmcz = [wmcz,wmcz];
[fcx1, fcx2, fcx3, fcx4] = trainLMSf(CX, wmcx, 32, ''); [fcz1, fcz2, fcz3, fcz4] = trainLMSf(CZ, wmcz, 32, '');
save flms25.mat fcx1 fcx2 fcx3 fcx4 fcz1 fcz2 fcz3 fcz4;


% OLD PCA filters train (detectPCAold):
clear all;

load CXZpm00_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm02_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm04_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm06_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
[y01cx, y02cx, y03cx] = trainPCAold(CX, 32);
load CXZpm00_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm20_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm40_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm60_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
[y01cz, y02cz, y03cz] = trainPCAold(CZ, 32); save wm0_32_25.mat y01cx y02cx y03cx y01cz y02cz y03cz; 

load CXZpm20_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm22_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm24_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm26_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
[y21cx, y22cx, y23cx] = trainPCAold(CX, 32);
load CXZpm02_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm22_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm42_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm62_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
[y21cz, y22cz, y23cz] = trainPCAold(CZ, 32); save wm2_32_25.mat y21cx y22cx y23cx y21cz y22cz y23cz; 

load CXZpm40_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm42_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm44_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm46_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
[y41cx, y42cx, y43cx] = trainPCAold(CX, 32);
load CXZpm04_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm24_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm44_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm64_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
[y41cz, y42cz, y43cz] = trainPCAold(CZ, 32); save wm4_32_25.mat y41cx y42cx y43cx y41cz y42cz y43cz; 

load CXZpm60_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm62_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm64_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm66_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
[y61cx, y62cx, y63cx] = trainPCAold(CX, 32);
load CXZpm06_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm26_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm46_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm66_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
[y61cz, y62cz, y63cz] = trainPCAold(CZ, 32); save wm6_32_25.mat y61cx y62cx y63cx y61cz y62cz y63cz; 
 
% NEW PCA filters train:
clear all;
load CXZpmrr_25.mat;
[Xpc1, Xpc2, Xpc3, Xpc4, Xpc5, Xpc6, Xpc7] = trainPCAf(CX, 32);
fcx1 = Xpc2;
fcx2 = Xpc3;
[Xpc1, Xpc2, Xpc3, Xpc4, Xpc5, Xpc6, Xpc7] = trainPCAf(CZ, 32);
fcz1 = Xpc2;
fcz2 = Xpc3;
save fpca25.mat fcx1 fcx2 fcz1 fcz2;

% train DICTs
clear all;
load CXZpm00_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm02_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm04_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm06_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
Dcx0 = trainDICTs(CX,32,'',128);
load CXZpm20_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm22_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm24_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm26_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
Dcx1 = trainDICTs(CX,32,'',128);
load CXZpm40_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm42_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm44_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm46_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
Dcx2 = trainDICTs(CX,32,'',128);
load CXZpm60_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm62_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm64_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm66_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
Dcx3 = trainDICTs(CX,32,'',128);

load CXZpm00_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm20_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm40_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm60_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
Dcz0 = trainDICTs(CZ,32,'',128);
load CXZpm02_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm22_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm42_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm62_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
Dcz1 = trainDICTs(CZ,32,'',128);
load CXZpm04_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm24_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm44_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm64_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
Dcz2 = trainDICTs(CZ,32,'',128);
load CXZpm06_25.mat; CX1 = CX; CZ1 = CZ; load CXZpm26_25.mat; CX2 = CX; CZ2 = CZ; load CXZpm46_25.mat; CX3 = CX; CZ3 = CZ; load CXZpm66_25.mat; CX4 = CX; CZ4 = CZ; CX = [CX1,CX2,CX3,CX4]; CZ = [CZ1,CZ2,CZ3,CZ4];
Dcz3 = trainDICTs(CZ,32,'',128);

save dict25_128.mat Dcx0 Dcx1 Dcx2 Dcx3 Dcz0 Dcz1 Dcz2 Dcz3;


%Get distributions for moments, LMS, and new PCA features

clear all;
mompdfs = cell(4,4,8);
lmspdfs = cell(4,4,8);
pcapdfs = cell(4,4,4);
bm = 80:60/100:140; dbm = bm(2)-bm(1);
b = -1:1/50:1; dbb = b(2)-b(1);
load scannerrgb2xyz.mat;
imnames = ['comb4500_25.tif';'comb4502_25.tif';'comb4504_25.tif';'comb4506_25.tif';'comb4520_25.tif';'comb4522_25.tif';'comb4524_25.tif';'comb4526_25.tif';'comb4540_25.tif';'comb4542_25.tif';'comb4544_25.tif';'comb4546_25.tif';'comb4560_25.tif';'comb4562_25.tif';'comb4564_25.tif';'comb4566_25.tif';];
count = 0;
for cxi = 1:4,
    for czi = 1:4,
        count = count + 1;
        i = imread(imnames(count,:));ir = img2row(i);ir = polyconvert3(ir',ABC)';y = xyz2ycc(ir); y = row2img(y,2400,4800); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
        [cx1s, cx2s, cx3s, cx4s, cz1s, cz2s, cz3s, cz4s] = trainmompdf(CX,CZ,32,2.5,2,1);
        h1 = hist(cx1s,bm);h2 = hist(cx2s,bm);h3 = hist(cx3s,bm);h4 = hist(cx4s,bm);h5 = hist(cz1s,bm);h6 = hist(cz2s,bm);h7=hist(cz3s,bm);h8=hist(cz4s,bm);
        h1 = h1/(sum(h1)*dbm);h2 = h2/(sum(h2)*dbm);h3 = h3/(sum(h3)*dbm);h4 = h4/(sum(h4)*dbm);h5 = h5/(sum(h5)*dbm);h6 = h6/(sum(h6)*dbm);h7 = h7/(sum(h7)*dbm);h8 = h8/(sum(h8)*dbm);
        mompdfs{cxi,czi,1} = h1;mompdfs{cxi,czi,2} = h2;mompdfs{cxi,czi,3} = h3;mompdfs{cxi,czi,4} = h4;mompdfs{cxi,czi,5} = h5;mompdfs{cxi,czi,6} = h6;mompdfs{cxi,czi,7} = h7;mompdfs{cxi,czi,8} = h8;
        [cx1s, cx2s, cx3s, cx4s, cz1s, cz2s, cz3s, cz4s] = trainlmspdf(CX,CZ,32,2.5,2,1,'n');
        h1 = hist(cx1s,b);h2 = hist(cx2s,b);h3 = hist(cx3s,b);h4 = hist(cx4s,b);h5 = hist(cz1s,b);h6 = hist(cz2s,b);h7=hist(cz3s,b);h8=hist(cz4s,b);
        h1 = h1/(sum(h1)*dbb);h2 = h2/(sum(h2)*dbb);h3 = h3/(sum(h3)*dbb);h4 = h4/(sum(h4)*dbb);h5 = h5/(sum(h5)*dbb);h6 = h6/(sum(h6)*dbb);h7 = h7/(sum(h7)*dbb);h8 = h8/(sum(h8)*dbb);
        lmspdfs{cxi,czi,1} = h1;lmspdfs{cxi,czi,2} = h2;lmspdfs{cxi,czi,3} = h3;lmspdfs{cxi,czi,4} = h4;lmspdfs{cxi,czi,5} = h5;lmspdfs{cxi,czi,6} = h6;lmspdfs{cxi,czi,7} = h7;lmspdfs{cxi,czi,8} = h8;
        [cx1s, cx2s, cz1s, cz2s] = trainpcapdf(CX,CZ,32,2.5,2,1);
        h1 = hist(cx1s,b);h2 = hist(cx2s,b);h3 = hist(cz1s,b);h4 = hist(cz2s,b);
        h1 = h1/(sum(h1)*dbb);h2 = h2/(sum(h2)*dbb);h3 = h3/(sum(h3)*dbb);h4 = h4/(sum(h4)*dbb);
        pcapdfs{cxi,czi,1} = h1;pcapdfs{cxi,czi,2} = h2;pcapdfs{cxi,czi,3} = h3;pcapdfs{cxi,czi,4} = h4;        
    end
end

save mompdfs25.mat mompdfs;
save lmspdfs25.mat lmspdfs;
save pcapdfs25.mat pcapdfs;

