function  [fc1, fc2, fc3, fc4] = trainLMSf(CC, wm, N, z) % CC is CX or CZ
r = size(CC,1);
c = size(CC,2);
wmr = floor(r/N);
wmc = floor(c/N);

S1 = 0; S2 = 0;
if N==32, Nf = 32; S1 = 1; S2 = 0; end


u1 = zeros(Nf,Nf);
u1new = zeros(Nf,Nf);
u2 = zeros(Nf,Nf);
u2new = zeros(Nf,Nf);
u3 = zeros(Nf,Nf);
u3new = zeros(Nf,Nf);
u4 = zeros(Nf,Nf);
u4new = zeros(Nf,Nf);


gama = 0.0000000001;
incth = 0.00001;
K=255;
minT = 11000;

finished1 = false;
finished2 = false;
finished3 = false;
finished4 = false;
finishnow = false;

count = 0;
for rr = 1:wmr,
    for cc = 1:wmc,
        count = count + 1;
        tempcb = CC((rr-1)*N+S1:rr*N-S2,(cc-1)*N+S1:cc*N-S2);       
        meanv = mean2(tempcb);
        tempcb = tempcb - meanv;
        tempcb = tempcb / (sqrt(sum2(tempcb.*tempcb)) + 0.001);
            
        u1 = u1new;
        vc1 = sum2(tempcb.*u1);
        if ((wm(rr*N,cc*N)==0)),
            esq1 = (K-vc1).^2;
        else
            esq1 = -(0-vc1).^2;
        end
        deriv1 = -2*sqrt(esq1).*tempcb;
        inc1 = -gama*deriv1/2;
        if (~finished1), u1new = u1 + inc1; end
        
        u2 = u2new;
        vc2 = sum2(tempcb.*u2);
        if ((wm(rr*N,cc*N)==70)),
            esq2 = (K-vc2).^2;
        else
            esq2 = (0-vc2).^2;
        end
        deriv2 = -2*sqrt(esq2).*tempcb;
        inc2 = - gama*deriv2/2;
        if (~finished2), u2new = u2 + inc2; end
            
        u3 = u3new;
        vc3 = sum2(tempcb.*u3);
        if ((wm(rr*N,cc*N)==140)),
            esq3 = (K-vc3).^2;
        else
            esq3 = (0-vc3).^2;
        end
        deriv3 = -2*sqrt(esq3).*tempcb;
        inc3 = - gama*deriv3/2;
        if (~finished3), u3new = u3 + inc3; end

        u4 = u4new;
        vc4 = sum2(tempcb.*u4);
        if ((wm(rr*N,cc*N)==210)),
            esq4 = (K-vc4).^2;
        else
            esq4 = (0-vc4).^2;
        end
        deriv4 = -2*sqrt(esq4).*tempcb;
        inc4 = - gama*deriv4/2;
        if (~finished4), u4new = u4 + inc4; end
            
        if ((sum2(abs(inc1))<incth)&&(count>minT)), finished1 = true; end;
        if ((sum2(abs(inc2))<incth)&&(count>minT)), finished2 = true; end;
        if ((sum2(abs(inc3))<incth)&&(count>minT)), finished3 = true; end;
        if ((sum2(abs(inc4))<incth)&&(count>minT)), finished4 = true; end;
        
        if (finished1&&finished2&&finished3&&finished4),
            finishnow = true;
            break; 
        end               

    end
    if (finishnow),
        break;
    end
end

fc1 = u1new/sqrt(sum2(u1new.*u1new));
fc2 = u2new/sqrt(sum2(u2new.*u2new));
fc3 = u3new/sqrt(sum2(u3new.*u3new));
fc4 = u4new/sqrt(sum2(u4new.*u4new));

end

